#/bin/sh

# ***********************************************************************************
# ********************** CREATE AND/OR OPEN THE VIVADO PROJECT **********************
# ***********************************************************************************

# ***********************************************************************************
# INSTRUCTIONS FOR EXECUTION: 
#	1. Install "Xilinx Vivado 2019.1" (including it to the PATH as well).
#	2. Open a terminal and execute the present file --> "sh run_vivado_project.sh"
#	3. Follow instructions
# ***********************************************************************************

# Displays a bunch of options, reads back the argument, and repeats if wrong value
echo -e -n "
Select an option:
  - Generate Vivado project (batch mode):	1
  - Generate Vivado project (GUI mode):		2
  - Open generated Vivado project:		3
  - Delete generated Vivado project:		4
  - Run Vivado TCL shell:			5
\n"

# Infinite loop until a number from 1 to 5 is entered
unset option
until [[ $option == [1-5] ]]; do
    read -r -p "Enter a valid number: " option
done

# Goes where the Vivado TCL framework is located
cd _vivado_framework/

# Executes the selected command
if [[ $option -eq 1 ]]; then
	vivado -mode batch -source generate_project.tcl
elif [[ $option -eq 2 ]]; then
	vivado -mode gui -source generate_project.tcl
elif [[ $option -eq 3 ]]; then
	vivado -mode gui ccsds123issue2_project/ccsds123issue2_project.xpr
elif [[ $option -eq 4 ]]; then
	rm -rf ccsds123issue2_project/; rm -rf artifacts/
	rm -rf .Xil/; rm *.log; rm *.jou; rm *.str; rm *.zip
else
	# This command does not work using "git bash"...
	vivado -mode tcl
fi

# Comes back to the original directory
cd ..